﻿package  {
	
	import flash.display.MovieClip;
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.utils.getDefinitionByName;
	
	import flare.basic.*;
	import flare.core.*;
	import flare.system.*;
	import flare.utils.*;
	import flare.loaders.*;
	
	public class Main extends MovieClip {
		
		[Embed (source = "car_1.zf3d", mimeType="application/octet-stream")]
		private var car_model:Class;
		
		private var scene:Scene3D;
		private var container3d:Pivot3D;
		private var car_loader:Flare3DLoader;
		
		private var cam_dist:int = 50;
		private var posX:int = 0;
		
		public function Main() {
			// constructor code
			scene = new Scene3D(this);
			scene.camera = new Camera3D("myCamera");
			scene.camera.setPosition(0, cam_dist, -cam_dist);
			scene.camera.lookAt(0,0,0);
			add_car();			
		}
		
		private function add_car():void{
			car_loader = new Flare3DLoader(new car_model, null, scene);
			car_loader.addEventListener(Event.COMPLETE, load_car);
			car_loader.load();
			car_loader.parent = scene;
		}
		
		private function load_car(e:Event):void{
			car_loader.setPosition(0,0,0);
			car_loader.getChildByName("lamp_1").hide();
			car_loader.getChildByName("lamp_2").hide();
			car_loader.getChildByName("lamp_3").hide();
			car_loader.getChildByName("lamp_4").hide();
			
			scene.resume();
			scene.addEventListener(Scene3D.UPDATE_EVENT, updateEvent);
		}
		
		private function updateEvent(e:Event):void{
			if (Input3D.keyDown(Input3D.UP)){
				posX+=2;
				car_loader.getChildByName("wheel01").rotateX(20);
				car_loader.getChildByName("wheel02").rotateX(20);
				car_loader.getChildByName("wheel03").rotateX(20);
				car_loader.getChildByName("wheel04").rotateX(20);
			}
			if (Input3D.keyDown(Input3D.DOWN)){
				posX-=2;
				car_loader.getChildByName("wheel01").rotateX(-20);
				car_loader.getChildByName("wheel02").rotateX(-20);
				car_loader.getChildByName("wheel03").rotateX(-20);
				car_loader.getChildByName("wheel04").rotateX(-20);
			}
			car_loader.setPosition(posX, 0, 0);
		}
	}
	
}
